using System;
using System.Collections.Generic;
using System.Web;

using System.Web.Caching;
using System.Text;

namespace CYQ.Tool
{
    public class WeatherInfo
    {
        private string imgUrl;
        /// <summary>
        /// ͼƬַ
        /// </summary>
        public string ImgUrl
        {
            get { return imgUrl; }
            set { imgUrl = value; }
        }
        private string wind;
        /// <summary>
        /// 
        /// </summary>
        public string Wind
        {
            get { return wind; }
            set { wind = value; }
        }
        private string cityName;
        /// <summary>
        /// 
        /// </summary>
        public string CityName
        {
            get { return cityName; }
            set { cityName = value; }
        }
        private string temperature;
        /// <summary>
        /// ¶
        /// </summary>
        public string Temperature
        {
            get { return temperature; }
            set { temperature = value; }
        }
        private string description;
        /// <summary>
        /// ˵
        /// </summary>
        public string Description
        {
            get { return description; }
            set { description = value; }
        }

    }
    public class WeatherSearch
    {
        /// <summary>
        /// ݲɼԴԤ
        /// </summary>
        /// <param name="cityName"></param>
        /// <returns></returns>
        public static WeatherInfo Get(string cityName)
        {
            if (string.IsNullOrEmpty(cityName))
            {
                return null;
            }
            string todayKey = cityName + DateTime.Now.ToString("yyyyMMdd");
            WeatherInfo weather = GetFormCache(cityName, todayKey);
            if (weather == null)
            {
                weather = new WeatherInfo();
                weather.CityName = cityName;
                cityName = System.Web.HttpUtility.UrlEncode(cityName + "", Encoding.GetEncoding("gb2312"));
                string url = "http://www.soso.com/q?num=1&w=" + cityName;

                //ɼhtml
                string html = GatherHelper.GetHtmlCode(url, Encoding.GetEncoding("gb2312"));
                if (string.IsNullOrEmpty(html)) { return null; }
                //СΧ
                //html = GatherHelper.GetContent(html, "<div class=\"w_main\">", "</div>", 1);
                html = GatherHelper.GetContent(html, "<div class=\"bo_58_cont\">", "</div>", 1);
                if (string.IsNullOrEmpty(html)) { return null; }

                //˵
                weather.Description = GatherHelper.GetContent(html, "<span class=\"w_w\">", "</span>", 1);
                //ͼƬ
                weather.ImgUrl = GatherHelper.GetContent(html, "<img src=\"", "\"", 1);
               
                //
                //weather.Wind=GatherHelper.GetContent(html, "title=\"", "\"", 1);
                weather.Wind = GatherHelper.GetContent(html, "title=\"", "\"", 3);

                //¶
                weather.Temperature = GatherHelper.GetContent(html, "/> <span>", "<em>", 1);
                
                HttpContext.Current.Cache.Insert(todayKey, weather);
                string yesterdayKey = cityName + DateTime.Now.AddDays(-1).ToString("yyyyMMdd");

                if (HttpContext.Current.Cache.Get(yesterdayKey)!=null)
                {
                    HttpContext.Current.Cache.Remove(yesterdayKey);
                }
            }
            return weather;
        }

        private static WeatherInfo GetFormCache(string cityName,string key)
        {
            object weather = HttpContext.Current.Cache.Get(key);
            if (weather!=null)
            {
                return weather as WeatherInfo;
            }
            return null;
        }

    }

}
